﻿/*
===============================================================================
 Name        : main.c
 Author      : Yoshihito Shimada
 Version     : V1.0
 Copyright   : Copyright (C) Yoshihito Shimada
 Description : main definition
===============================================================================
*/

//ヘッダファイルの読み込み
#include "LPC8xx.h"
#include "lpc8xx_uart.h"
#include "lpc8xx_mrt.h"
#include <string.h>
#define RCK     3   // ラッチ出力信号(PIO0_3)
#define SER     1   // シリアルデータ出力信号(PIO0_1)
#define SCK     2   // クロック出力信号(PIO0_2)

//#define	X_RESOLUTION	320		/* X軸解像度*/
//#define	Y_RESOLUTION	240		/* Y軸解像度*/
#define	X_RESOLUTION	480		/* X軸解像度*/
#define	Y_RESOLUTION	272		/* Y軸解像度*/

extern volatile uint32_t UARTRxCount;           // UART受信カウント変数
uint32_t outCount;           // UART受信カウント変数
extern volatile uint8_t UARTRxBuffer[BUFSIZE];  // 受信データ格納変数
char data[32];
int j = 0;
int k = 0;
int l = 0;
int hold = 0;

int iX = 1000;
int iY = 1000;

unsigned char	ucMin_AD_x;//MIN_AD_X;		/* X軸A/D変換値　MIN*/
unsigned char	ucMax_AD_x;//MAX_AD_X;		/* X軸A/D変換値　MAX*/
unsigned char	ucMin_AD_y;//MIN_AD_Y;		/* Y軸A/D変換値　MIN*/
unsigned char	ucMax_AD_y;//MAX_AD_Y;		/* Y軸A/D変換値　MAX*/

void degit_disp(uint8_t n);                     // 7セグLED表示用関数

/*ボール遊び用*/
int xball = 25;
int yball = 220;
unsigned short ballcolor1 = BLUE;
unsigned short ballcolor2 = LIGHT_RED;
#define BLUECOLOR1 ((ballcolor1 >> 0) & 0x001f)
#define GREENCOLOR1 ((ballcolor1 >> 5) & 0x003f)
#define REDCOLOR1 ((ballcolor1 >> 11) & 0x001f)

void SwitchMatrix_Init()
{
    /* Enable SWM clock */
    LPC_SYSCON->SYSAHBCLKCTRL |= (1<<7);

    /* Pin Assign 8 bit Configuration */
    /* U0_TXD */
    /* U0_RXD */
    LPC_SWM->PINASSIGN0 = 0xffff0004UL;

    /* Pin Assign 1 bit Configuration */
    /* RESET */
    LPC_SWM->PINENABLE0 = 0xffffffbfUL;
}

/*****************************
	関数名：htoi
	引数：ポインタ配列
	戻り値：１０進数

	１６進数のようにでかかれたキャラ
	クタを、１０進数に直す。
******************************/
short htoi(char *ptr3)
{
	unsigned short v;

	for(v=0;(*ptr3 >= '0' && *ptr3 <= '9')||(*(ptr3) >= 'A' && *(ptr3) <= 'F')||(*(ptr3) >= 'a' && *(ptr3) <= 'f');ptr3++){
		if(*(ptr3) >= '0' && *(ptr3) <= '9') v = v*0x10+(*ptr3-0x30);
		else if(*(ptr3) >= 'A' && *(ptr3) <= 'F') v = v*0x10+(*ptr3-0x37);
		else if(*(ptr3) >= 'a' && *(ptr3) <= 'f') v = v*0x10+(*ptr3-0x57);
	}
	return v;
}
/********************************************************************
	関数名
		ASC2
	引数
		なし
	戻り値
		なし
	説明
		入力コマンドを認識。
********************************************************************/
void ASC2(void){
//	int i;
//	unsigned char boss[3];

	if(outCount != UARTRxCount){
		if(UARTRxBuffer[outCount] == 0x74 && j == 0){ //コマンドをtとする
			data[0] = 0x01;
			j++;
		}
		else if(j >= 1 && data[0] == 0x01){
			data[j] = UARTRxBuffer[outCount];
			//その上で
//			if((data[j] == 0x0d) && (k == 9)){
			if((data[j] == 0x0d) && (k == 7)){
				k=0;
				data[0] = 0x74;
				j = -1;
			}
//			else if(data[j] <= 0x31 && data[j] >= 0x30 && k == 0){
//				k++;
//			}
			else if((data[j] <= 0x31 && data[j] >= 0x30 && k == 0) || (((data[j] <= 0x46 && data[j] >= 0x41) || (data[j] <= 0x66 && data[j] >= 0x61) || (data[j] <= 0x39 && data[j] >= 0x30)) && k <= 6 && k >= 1)){
//			else if((((data[j] <= 0x46 && data[j] >= 0x41) || (data[j] <= 0x66 && data[j] >= 0x61) || (data[j] <= 0x39 && data[j] >= 0x30)) && k <= 6 && k >= 1)){
				k++;
			}
/*			else if(k <= 8 && k >= 7){
				k++;
			}
*/			else{
				memset(data,0x00,32);
				k=0;
				j = -1;
			}
			j++;
		}
		else{
			j = k = 0;
			memset(data,0x00,32);
		}
		outCount++;

		if(outCount >= 32){
			outCount = 0;
		}
		if(outCount == UARTRxCount){
			outCount = 0;
			UARTRxCount = 0;
		}
	}
}
/********************************************************************
	関数名
		fnputus
	引数
		キャラクタ
	戻り値
		なし
	説明
		シリアル送信のキャラクタ表示
		チェックサムを入れ「ない」シリアル送信のキャラクタ表示
********************************************************************/
void	fnputus1(unsigned char *ucp)
{

	while( *ucp != '\0' ){
		if(*ucp != 0x0d ) fnputchar(LPC_USART0, *ucp );
		ucp++;
	}
//	fnputchar(0x0d);
//	fnputchar(LF);
}
/********************************************************************
	関数名
		ASCC
	引数
		なし
	戻り値
		なし
	説明
		１６進数をASCⅡコードに変更して出力。
********************************************************************/
int ASC3(int asc){
	uint8_t boss[4];
	int i=0;
	boss[3]= '\0' ;
	for(i=0;i<=2;i++){
		if(((asc>>((2-i)*4)) & 0x0f) <=0x09) boss[i]=(((asc>>((2-i)*4)) & 0x0f)+0x30);
		if(((asc>>((2-i)*4)) & 0x0f) > 0x09) boss[i]=(((asc>>((2-i)*4)) & 0x0f)+0x37);
	}
	fnputus1((unsigned char*)boss);
	return boss[0] + boss[1] + boss[2];
}
int ASC4(int asc){
	uint8_t boss[5];
	int i=0;
	boss[4]= '\0' ;
	for(i=0;i<=3;i++){
		if(((asc>>((3-i)*4)) & 0x0f) <=0x09) boss[i]=(((asc>>((3-i)*4)) & 0x0f)+0x30);
		if(((asc>>((3-i)*4)) & 0x0f) > 0x09) boss[i]=(((asc>>((3-i)*4)) & 0x0f)+0x37);
	}
	fnputus1((unsigned char*)boss);
	return boss[0] + boss[1] + boss[2] + boss[3];
}
/********************************************************************
	関数名
		fnReadthree
	引数
		なし
	戻り値
		なし
	説明
        タッチパネルコマンド返信読み出し
********************************************************************/
void fntget(void){
        char LCDCdataX[4]={0x00,0x00,0x00,'\0'},LCDCdataY[4]={0x00,0x00,0x00,'\0'};
    	if(data[0] == 0x74){

			LCDCdataX[0] = data[2];
			LCDCdataX[1] = data[3];
			LCDCdataX[2] = data[4];
			LCDCdataX[3] = '\0';

			LCDCdataY[0] = data[5];
			LCDCdataY[1] = data[6];
			LCDCdataY[2] = data[7];
			LCDCdataY[3] = '\0';

			iX = htoi(LCDCdataX) / 2;
			iY = htoi(LCDCdataY) / 3 - 30;
//			iX = htoi(LCDCdataX);
//			iY = htoi(LCDCdataY);
			if(data[2] == 0x30 && data[3] == 0x30 && data[4] == 0x30 && data[5] == 0x30 && data[6] == 0x30 && data[7] == 0x30)iX = iY = 1000;
			memset(data,0x00,32);
    	}
}

/********************************************************************
	関数名
		fnRTSwait
	引数
		なし
	戻り値
		なし
	説明
        RTSが0になるまで待機
********************************************************************/
void fnRTSwait(void){

    volatile int8_t SW1=0;
 //   unsigned int a=0;
    SW1 = ( LPC_GPIO_PORT->PIN0 & (1 << 2) ) >> 2;
    while(SW1 == 1){
    	SW1 = ( LPC_GPIO_PORT->PIN0 & (1 << 2) ) >> 2;
 //   	a++;
 //  	if(a >= 0xffff)SW1 = 0;
    }

}

/********************************************************************
	関数名
		fnWLine
	引数
		なし
	戻り値
		なし
	説明
        線を書くコマンド送信
********************************************************************/

void fnWLine(unsigned int s, unsigned int x1,unsigned int  y1,unsigned int x2,unsigned int  y2,unsigned short color){
	int a=0;

	fnRTSwait();

	fnputchar(LPC_USART0,0x4c);
	a = a + 0x4c;
	fnputchar(LPC_USART0,(s & 0x0f)+0x30);

	a = a + (s & 0x0f)+0x30;
	a = a + ASC3(x1);
	a = a + ASC3(y1);
	a = a + ASC3(x2);
	a = a + ASC3(y2);
	a = a + ASC4(color);

//	fnputchar(LPC_USART0,0x30 + ((a & 0xf0)>>4));
//	fnputchar(LPC_USART0,0x30 + (a & 0x0f));

	fnputchar(LPC_USART0,0x0d);
}

/********************************************************************
	関数名
		fnWPaintBoxC
	引数
		なし
	戻り値
		なし
	説明
		左上と右下で色が異なる、線だけのボックスを作る。
********************************************************************/

void fnWPaintBoxC(unsigned int x1,unsigned int  y1,unsigned int x2,unsigned int  y2,unsigned short color,unsigned short color2){

	fnRTSwait();

	fnWLine(0,x1,y1,x2,y1,color);
	fnWLine(0,x1,y1,x1,y2,color);
	fnWLine(0,x1,y2,x2,y2,color2);
	fnWLine(0,x2,y1,x2,y2,color2);
}

/********************************************************************
	関数名
		fnWPaintBox
	引数
		なし
	戻り値
		なし
	説明
        四角を書くコマンド送信
********************************************************************/

void fnWPaintBox(unsigned int s,unsigned int x1,unsigned int  y1,unsigned int x2,unsigned int  y2,unsigned short color){
	int a=0;

	fnRTSwait();

	fnputchar(LPC_USART0,0x42);
	a = a + 0x42;
	fnputchar(LPC_USART0,(s & 0x0f)+0x30);
	a = a + (s & 0x0f)+0x30;

	a = a + ASC3(x1);
	a = a + ASC3(y1);
	a = a + ASC3(x2);
	a = a + ASC3(y2);
	a = a + ASC4(color);

//	fnputchar(LPC_USART0,0x30 + ((a & 0xf0)>>4));
//	fnputchar(LPC_USART0,0x30 + (a & 0x0f));

	fnputchar(LPC_USART0,0x0d);
}

/********************************************************************
	関数名
		fnWCircle
	引数
		なし
	戻り値
		なし
	説明
        円を書くコマンド送信
********************************************************************/

void fnWCircle(unsigned int s,unsigned int x1,unsigned int y1,unsigned int Radx,unsigned int Rady,unsigned int height,unsigned short color,unsigned short bgcolor){
	int a=0;

	fnRTSwait();

	fnputchar(LPC_USART0,0x43);
	a = a + 0x43;
	fnputchar(LPC_USART0,(s & 0x0f)+0x30);
	a = a + (s & 0x0f)+0x30;

	a = a + ASC3(x1);
	a = a + ASC3(y1);
	a = a + ASC3(Radx);
	a = a + ASC3(Rady);
	a = a + ASC3(height);
	a = a + ASC4(color);
	a = a + ASC4(bgcolor);

//	fnputchar(LPC_USART0,0x30 + ((a & 0xf0)>>4));
//	fnputchar(LPC_USART0,0x30 + (a & 0x0f));

	fnputchar(LPC_USART0,0x0d);

}

/********************************************************************
	関数名
		fnWPutC
	引数
		なし
	戻り値
		なし
	説明
        文字を書くコマンド送信
********************************************************************/
void fnWPutC(unsigned int font,unsigned int size,unsigned int x1,unsigned int y1,unsigned short color,unsigned short bgcolor,unsigned char *cp){
	int a=0,i=0;
	fnRTSwait();
	fnputchar(LPC_USART0,0x46);
	a = a + 0x46;
	fnputchar(LPC_USART0,(font & 0x0f)+0x30);
	a = a + (font & 0x0f)+0x30;
	fnputchar(LPC_USART0,(size & 0x0f)+0x30);
	a = a + (size & 0x0f)+0x30;
	a = a + ASC3(x1);
	a = a + ASC3(y1);
	a = a + ASC4(color);
	a = a + ASC4(bgcolor);
	i=0;
	while( *cp != '\0'){
		if(i>=40)break;
		fnputchar(LPC_USART0,*cp);
		a = a + *cp;
		cp++;
		i++;
	}
//	fnputchar(LPC_USART0,0x30 + ((a & 0xf0)>>4));
//	fnputchar(LPC_USART0,0x30 + (a & 0x0f));
	fnputchar(LPC_USART0,0x0d);
//	fnputchar(LPC_USART0,0x0a);
}
/********************************************************************
	関数名
		fnW7seg
	引数
		なし
	戻り値
		なし
	説明
        7セグを書くコマンド送信
********************************************************************/

void fnW7seg(unsigned int size,unsigned int digit,unsigned int x1,unsigned int y1,unsigned short color,unsigned short bgcolor,unsigned int font){
	int a=0;
	fnRTSwait();
	fnputchar(LPC_USART0,0x53);
	a = a + 0x53;
	fnputchar(LPC_USART0,(size & 0x0f)+0x30);
	a = a + (size & 0x0f)+0x30;
	fnputchar(LPC_USART0,(digit & 0x0f)+0x30);
	a = a + (digit & 0x0f)+0x30;

	a = a + ASC3(x1);
	a = a + ASC3(y1);
	a = a + ASC4(color);
	a = a + ASC4(bgcolor);

	if(font >= 10000){
		fnputchar(LPC_USART0,(font%100000)/10000 + 0x30);
		a = a + (font%100000)/10000 + 0x30;
	}
	if(font >= 1000){
		fnputchar(LPC_USART0,(font%10000)/1000 + 0x30);
		a = a + (font%10000)/1000 + 0x30;
	}
	if(font >= 100){
		fnputchar(LPC_USART0,(font%1000)/100 + 0x30);
		a = a + (font%1000)/100 + 0x30;
	}
	if(font >= 10){
		fnputchar(LPC_USART0,(font%100)/10 + 0x30);
		a = a + (font%100)/10 + 0x30;
	}
	fnputchar(LPC_USART0,(font%10)/1 + 0x30);
	a = a + (font%10)/1 + 0x30;

//	fnputchar(LPC_USART0,0x30 + ((a & 0xf0)>>4));
//	fnputchar(LPC_USART0,0x30 + (a & 0x0f));
	fnputchar(LPC_USART0,0x0d);

}

/********************************************************************
	関数名
		fnReadone
	引数
		なし
	戻り値
		なし
	説明
        タッチパネルコマンド送信
********************************************************************/
void fnReadone(unsigned int b){
	int a=0;

	fnRTSwait();

	fnputchar(LPC_USART0,0x74);
	a = a + 0x74;

	if(b <= 9 && b >= 0){
		fnputchar(LPC_USART0,b + 0x30);
		a = a + b + 0x30;
	}

//	fnputchar(LPC_USART0,0x30 + ((a & 0xf0)>>4));
//	fnputchar(LPC_USART0,0x30 + (a & 0x0f));

	fnputchar(LPC_USART0,0x0d);
}
/********************************************************************
	関数名
		fnswitch
	引数
		なし
	戻り値
		なし
	説明
		スイッチ作成用の関数
********************************************************************/
void fnsyokimozi(unsigned short color, unsigned short bgcolor){
	int i = 0;
	for(i=0;i<2;i++){
		fnWPutC(1,3,88,124+i*135,color,bgcolor,(unsigned char *)"-");
		fnWPutC(1,3,208,124+i*135,color,bgcolor,(unsigned char *)"+");
		/*defaultを含めない場合はここをコメントアウトする*/
		fnWPutC(1,0,302,113+i*135,color,bgcolor,(unsigned char *)"default");
	}
}
void fnsyokimozia(unsigned short color, unsigned short bgcolor,unsigned int morp,unsigned int line){
//	int i = 0;
	if(morp == 0){
		fnWPutC(1,0,302,113+line*135,color,bgcolor,(unsigned char *)"default");
	}
	else if(morp == 1){
		fnWPutC(1,3,208,124+line*135,color,bgcolor,(unsigned char *)"+");
	}
	else if(morp == 2){
		fnWPutC(1,3,88,124+line*135,color,bgcolor,(unsigned char *)"-");
	}
}

void fnLED(unsigned int morp,unsigned int line){
	if(line == 0 && (((morp == 1) && (LEDkido < 10)) || ((morp == 2) && (LEDkido > 0)) || morp == 0)){
		fnWCircle(0,LEDkido * 40 + 10,30,5,5,0,WHITE,WHITE);
		LEDkido = LEDkido + (1-(morp-1)*2);
//		if(morp == 0)LEDkido = 10;
		if(morp == 0)LEDkido = 5;
		fnWCircle(0,LEDkido * 40 + 10,30,5,5,0,BLACK,BLACK);
	}
	if(line == 1 && (((morp == 1) && (LEDblink < 10)) || ((morp == 2) && (LEDblink > 0)) || morp == 0)){
		fnWCircle(0,LEDblink * 40 + 10,30+135,5,5,0,WHITE,WHITE);
		LEDblink = LEDblink + (1-(morp-1)*2);
		if(morp == 0)LEDblink = 0;
		fnWCircle(0,LEDblink * 40 + 10,30+135,5,5,0,BLACK,BLACK);
	}
}

void fnswitch(unsigned int x1 , unsigned int y1 , unsigned int x2 , unsigned int y2 , unsigned short color , unsigned short bgcolor,unsigned int morp,unsigned int line){
//	int i = 0;

	fnWPaintBox(0,x1,y1,x2,y2,bgcolor);
	fnWPaintBox(1,x1,y1,x2,y2,color);
	fnsyokimozia(WHITE,bgcolor,morp,line);
	mrt_counter3 = 1000;
	while((iX != 1000) && (iY != 1000)){
		ASC2();
		fntget();

		if(mrt_counter3 == 0){
			mrt_counter3 = 300;
			fnLED(morp,line);
			hold = 1;
		}

	}
	fnWPaintBox(0,x1,y1,x2,y2,color);
	fnWPaintBox(1,x1,y1,x2,y2,bgcolor);
	fnsyokimozia(BLACK,color,morp,line);
}
void fnballswitch(unsigned int x1 , unsigned int y1 , unsigned int x2 , unsigned int y2 , unsigned short color , unsigned short bgcolor,unsigned int morp,unsigned int line){

	if(iX >= x1 && iX <= x2 && iY >= y1 && iY <= y2){
		fnswitch(x1,y1,x2,y2,color,bgcolor,morp,line);
		if(hold != 1)fnLED(morp,line);
		else hold = 0;
	}
}
/********************************************************************
	関数名
		fnbsetteifirst
	引数
		なし
	戻り値
		なし
	説明
		ボール画面設定初期画面
********************************************************************/
void fnballs(void){

	int i = 0,j=0;

	//全体
	fnWPaintBox(0,0,0,479,271,WHITE);
	fnWCircle(0,LEDkido * 40 + 10,30,5,5,0,BLACK,BLACK);
	fnWCircle(0,LEDblink * 40 + 10,165,5,5,0,BLACK,BLACK);
	for(i=0;i<=1;i++){
		for(j=0;j<=10;j++){
//			fnWLine(0,j*40+10,38+135*i,j*40+10,42+135*i,BLACK);
			fnWPaintBox(0,j*40+9,36+135*i,j*40+11,44+135*i,BLACK);
		}
//		fnWLine(0,10,40+i*135,410,40+i*135,BLACK);
		fnWPaintBox(0,10,39+i*135,410,41+i*135,BLACK);
		/*defaultを含めない場合はここをj<=1にする*/
		for(j=0;j<=2;j++){
			fnWPaintBox(1,50+j*120,70+135*i,150+j*120,130+135*i,BLUE);
		}

		fnWPutC(1,3,88,124+i*135,BLACK,WHITE,(unsigned char *)"-");
		fnWPutC(1,3,208,124+i*135,BLACK,WHITE,(unsigned char *)"+");
		fnWPutC(1,0,302,113+i*135,BLACK,WHITE,(unsigned char *)"default");

		fnWPutC(0,0,6,60+i*135,BLACK,WHITE,(unsigned char *)"0");
		fnWPutC(0,0,402,60+i*135,BLACK,WHITE,(unsigned char *)"10");
	}
//	fnsyokimozi(BLACK,WHITE);
//	fnsyokimozia(BLACK,WHITE,4,4);
	//文字系
	fnWPutC(0,0,10,20,BLACK,WHITE, (unsigned char *)"brightness");
	fnWPutC(0,0,10,20+135,BLACK,WHITE, (unsigned char *)"blink");
//	fnWPutC(0,0,10,20,BLACK,WHITE, (unsigned char *)"LED brightness");
//	fnWPutC(0,0,10,20+135,BLACK,WHITE, (unsigned char *)"LED blink speed");
	/*defaultを含めない場合はここをコメントアウトする*/
//	fnWPutC(0,0,324,120,BLACK,WHITE,(unsigned char *)"(10)");
//	fnWPutC(0,0,328,120+135,BLACK,WHITE,(unsigned char *)"(0)");

}
/********************************************************************
	関数名
		fnrsetteigamen
	引数
		なし
	戻り値
		なし
	説明
		ボール画面設定画面
********************************************************************/
void fnball(void){
	int i=0,j=0;
	ASC2();
	fntget();
	for(i=0;i<=2;i++){
		for(j=0;j<=1;j++){
			fnballswitch(50+i*120,70+135*j,150+i*120,130+135*j,WHITE,BLUE,2-i,j);
//			fnballswitch(50+i*120,70+135*j,150+i*120,130+135*j,GRAY,BLUE,2-i,j);
		}
	}
}

/********************************************************************
	関数名
		main
	引数
		なし
	戻り値
		なし
	説明
		メイン。初期輝度を0に変更した社内用特注型。
		さらに、default押下時の変更値を5に変更する。
********************************************************************/
int main(void){
	int i,j;
//  volatile int8_t SW1;
//    ucMin_AD_x=0x10;		/* X軸A/D変換値　MIN*/
//    ucMax_AD_x=0xeD;		/* X軸A/D変換値　MAX*/
//    ucMin_AD_y=0x10;		/* Y軸A/D変換値　MIN*/
//    ucMax_AD_y=0xeD;		/* Y軸A/D変換値　MAX*/

	UARTInit(LPC_USART0, 115200);                     // UART初期化関数(115200bpsに設定)
//	UARTInit(LPC_USART0, 38400);                     // UART初期化関数(38400bpsに設定)

  	SwitchMatrix_Init();                              // スイッチ・マトリックスの設定

    //ポートの方向決定（出力ポートに設定）
    LPC_GPIO_PORT->DIR0 |= (1 << RCK);                // ラッチ出力信号端子(PIO0_3)
    LPC_GPIO_PORT->DIR0 &= ~(1 << 1);       		  // PIO0_1 を入力ポートに設定
    LPC_GPIO_PORT->DIR0 &= ~(1 << 2);       		  // PIO0_2 を入力ポートに設定

    init_mrt(SystemCoreClock / 1000); //1msタイマー

    //ここからコマンドドリブン
	fnballs();
	fnReadone(1);
	for(;;){
		fnball();
		if(LEDkidoflag == 1){
			if(LEDkido >= 5)i = 100;
			else if(LEDkido >= 4)i = 50;
			else if(LEDkido >= 3)i = 10;
			else if(LEDkido >= 2)i = 5;
			else i = LEDkido;
			for(j = 0 ; j <= 200 ; j++){
				if(j > i){
					LPC_GPIO_PORT->CLR0 =  1 << 3;
				}
				else{
					LPC_GPIO_PORT->SET0 =  1 << 3;
				}
			}
		}
	}

    //ここまでコマンドドリブン


}



