﻿/*
===============================================================================
 Name        : main.c
 Author      : Yoshihito Shimada
 Version     : V1.0
 Copyright   : Copyright (C) Yoshihito Shimada
 Description : main definition
===============================================================================
*/

//ヘッダファイルの読み込み
#include "LPC8xx.h"
#include "lpc8xx_uart.h"
#include "lpc8xx_mrt.h"
#include <string.h>
#define RCK     3   // ラッチ出力信号(PIO0_3)
#define SER     1   // シリアルデータ出力信号(PIO0_1)
#define SCK     2   // クロック出力信号(PIO0_2)

//#define	X_RESOLUTION	320		/* X軸解像度*/
//#define	Y_RESOLUTION	240		/* Y軸解像度*/
#define	X_RESOLUTION	480		/* X軸解像度*/
#define	Y_RESOLUTION	272		/* Y軸解像度*/

extern volatile uint32_t UARTRxCount;           // UART受信カウント変数
uint32_t outCount;           // UART受信カウント変数
extern volatile uint8_t UARTRxBuffer[BUFSIZE];  // 受信データ格納変数
char data[32];
int hold = 0;
int hold2 = 0;

int iX = 1000;
int iY = 1000;

unsigned char	ucMin_AD_x;//MIN_AD_X;		/* X軸A/D変換値　MIN*/
unsigned char	ucMax_AD_x;//MAX_AD_X;		/* X軸A/D変換値　MAX*/
unsigned char	ucMin_AD_y;//MIN_AD_Y;		/* Y軸A/D変換値　MIN*/
unsigned char	ucMax_AD_y;//MAX_AD_Y;		/* Y軸A/D変換値　MAX*/

void degit_disp(uint8_t n);                     // 7セグLED表示用関数

/*スイッチ遊び用*/
unsigned short ucSwitchOld = 0x0017;
unsigned short ucSwitchNew = 0x0017;
unsigned short ucSwitchUP;
unsigned short ucSwitchDN;
int kidoflag = 0;
int blinkflag = 0;
#define SWITCH1 0x04
#define SWITCH2 0x10
#define SWITCH4 0x01
#define SWITCH5 0x02

void SwitchMatrix_Init()
{
    /* Enable SWM clock */
    LPC_SYSCON->SYSAHBCLKCTRL |= (1<<7);

    /* Pin Assign 8 bit Configuration */
    /* none */

    /* Pin Assign 1 bit Configuration */
    /* RESET */
    LPC_SWM->PINENABLE0 = 0xffffffbfUL;
}


/*****************************
	関数名：htoi
	引数：ポインタ配列
	戻り値：１０進数

	１６進数のようにでかかれたキャラ
	クタを、１０進数に直す。
******************************/
short htoi(char *ptr3)
{
	unsigned short v;

	for(v=0;(*ptr3 >= '0' && *ptr3 <= '9')||(*(ptr3) >= 'A' && *(ptr3) <= 'F')||(*(ptr3) >= 'a' && *(ptr3) <= 'f');ptr3++){
		if(*(ptr3) >= '0' && *(ptr3) <= '9') v = v*0x10+(*ptr3-0x30);
		else if(*(ptr3) >= 'A' && *(ptr3) <= 'F') v = v*0x10+(*ptr3-0x37);
		else if(*(ptr3) >= 'a' && *(ptr3) <= 'f') v = v*0x10+(*ptr3-0x57);
	}
	return v;
}
/********************************************************************
	関数名
		fnLEDflag
	引数
		なし
	戻り値
		なし
	説明
       LED点灯フラグ
********************************************************************/
void fnkidoflag(int k){
	if(k < 0 && LEDkido > 0)LEDkido--;
	if(k > 0 && LEDkido < 10)LEDkido++;
}
void fnblinkflag(int b){
	if(b < 0 && LEDblink > 0)LEDblink--;
	if(b > 0 && LEDblink < 10)LEDblink++;
}
/********************************
	関数名：fnGetSwitch
	引数：ucSwitchOld、ucSwitchNew
	戻り値：なし

	スイッチ情報の取得
*********************************/
void fnGetSwitch(void){
	ucSwitchOld = ucSwitchNew;
	ucSwitchNew = ((LPC_GPIO_PORT->PIN0)&0x0017);

	ucSwitchUP = ((ucSwitchOld | ucSwitchNew)^ucSwitchOld); //立ち上がりON
	ucSwitchDN = ((ucSwitchOld | ucSwitchNew)^ucSwitchNew);	//立ち下がりON

}
/********************************************************************
	関数名
		fnSetSwitch
	引数
		なし
	戻り値
		なし
	説明
        スイッチを押された時の反応
********************************************************************/
void fnSetSwitch(void){

	if(ucSwitchDN&SWITCH4){//スイッチ押下時
		mrt_counter3 = 1000;
		hold = 1;
		kidoflag=-1;
	}
	if(ucSwitchUP&SWITCH4){//スイッチから指を離す
		if(hold == 2);
		else fnkidoflag(kidoflag);
		if(((LPC_GPIO_PORT->PIN0 & (SWITCH5) ) >> 1 ) != 0){
			mrt_counter3 = 0;
			kidoflag=0;
			hold = 0;
		}
	}
	if(ucSwitchDN&SWITCH5){//スイッチ押下時
		mrt_counter3 = 1000;
		hold = 1;
		kidoflag=1;
	}
	if(ucSwitchUP&SWITCH5){//スイッチから指を離す
		if(hold == 2);
		else fnkidoflag(kidoflag);
		if(((LPC_GPIO_PORT->PIN0 & (SWITCH4) ) >> 0 ) != 0){
			mrt_counter3 = 0;
			kidoflag=0;
			hold = 0;
		}
	}

	if(ucSwitchDN&SWITCH1){//スイッチ押下時
		mrt_counter4 = 1000;
		hold2 = 1;
		blinkflag=-1;
	}
	if(ucSwitchUP&SWITCH1){//スイッチから指を離す
		if(hold2 == 2);
		else fnblinkflag(blinkflag);
		if(((LPC_GPIO_PORT->PIN0 & (SWITCH2) ) >> 4 ) != 0)	{
			mrt_counter4 = 0;
			blinkflag=0;
			hold2 = 0;
		}
	}
	if(ucSwitchDN&SWITCH2){//スイッチ押下時
		mrt_counter4 = 1000;
		hold2 = 1;
		blinkflag=1;
	}
	if(ucSwitchUP&SWITCH2){//スイッチから指を離す
		if(hold2 == 2);
		else fnblinkflag(blinkflag);
		if(((LPC_GPIO_PORT->PIN0 & (SWITCH1) ) >> 2 ) != 0){
			mrt_counter4 = 0;
			blinkflag=0;
			hold2 = 0;
		}
	}

	if(mrt_counter3 <= 0){
		mrt_counter3 = 300;
		fnkidoflag(kidoflag);
		hold = 2;
	}
	if(mrt_counter4 <= 0){
		mrt_counter4 = 300;
		fnblinkflag(blinkflag);
		hold2 = 2;
	}

}

/********************************************************************
	関数名
		main
	引数
		なし
	戻り値
		なし
	説明
		メイン。初期輝度を0にした、社内特注型。
********************************************************************/
int main(void){
	int i,j;

	UARTInit(LPC_USART0, 115200);                     // UART初期化関数(115200bpsに設定)
//	UARTInit(LPC_USART0, 38400);                     // UART初期化関数(38400bpsに設定)

  	SwitchMatrix_Init();                              // スイッチ・マトリックスの設定

    //ポートの方向決定（出力ポートに設定）
    LPC_GPIO_PORT->DIR0 |= (1 << RCK);                // ラッチ出力信号端子(PIO0_3)
    LPC_GPIO_PORT->DIR0 &= ~(1 << 0);       		  // PIO0_0 を入力ポートに設定
    LPC_GPIO_PORT->DIR0 &= ~(1 << 1);       		  // PIO0_1 を入力ポートに設定
    LPC_GPIO_PORT->DIR0 &= ~(1 << 2);       		  // PIO0_2 を入力ポートに設定
    LPC_GPIO_PORT->DIR0 &= ~(1 << 4);       		  // PIO0_4 を入力ポートに設定

    init_mrt(SystemCoreClock / 1000); //1msタイマー

	for(;;){
		if(mrt_counter5 == 0){
			fnGetSwitch();
			fnSetSwitch();
			mrt_counter5 = 10;
		}
		if(LEDkidoflag == 1){
			if(LEDkido >= 5)i = 100;
			else if(LEDkido >= 4)i = 50;
			else if(LEDkido >= 3)i = 10;
			else if(LEDkido >= 2)i = 5;
			else i = LEDkido;

			for(j = 0 ; j <= 200 ; j++){
				if(j > i){
					LPC_GPIO_PORT->CLR0 =  1 << 3;
				}
				else{
					LPC_GPIO_PORT->SET0 =  1 << 3;
				}
			}
		}
	}
}



